(PackageInfo named: 'OB-ToggleNav') postscriptOfRemoval: '"below, add code to clean up after the unloading of this package"'!
(PackageInfo named: 'OB-ToggleNav') preamble: '"below, add code to be run before the loading of this package"'!
(PackageInfo named: 'OB-ToggleNav') postscript: '"below, add code to be run after the loading of this package"
OBSystemBrowser ensureInstVarsExist.'!
(PackageInfo named: 'OB-ToggleNav') preambleOfRemoval: '"below, add code to prepare for the unloading of this package"'!

!OBMethodNode methodsFor: '*OB-ToggleNav' stamp: 'bs 1/13/2011 20:48:50.716'!
title
	^ (self theClass >> self selector) qualifiedName! !

!OBSystemBrowser class methodsFor: '*OB-ToggleNav' stamp: 'bs 2/2/2011 14:26:20.622'!
ensureInstVarsExist
	self toggleNavInstVars do: [:ea | 
		(self instVarNames includes: ea) 
			ifFalse: [self addInstVarName: ea] ]! !

!OBSystemBrowser class methodsFor: '*OB-ToggleNav' stamp: 'bs 2/2/2011 13:50:13.663'!
toggleNavInstVars
	^ {'window'. 'navView'}! !

!OBSystemBrowser methodsFor: '*OB-ToggleNav' stamp: 'bs 2/2/2011 13:38:22.738'!
buildOn: aBuilder
	| label |
	window := super buildOn: aBuilder.
	navView := window submorphs detect: [:ea | ea isKindOf: OBGroupingMorph].
	window on: #mouseLeave send: #turnOffNavView to: self.
	window on: #mouseEnter send: #turnOnNavView to: self.
	label := window instVarNamed: 'label'.
	label on: #mouseUp send: #toggleNavigation to: self.
	^ window! !

!OBSystemBrowser methodsFor: '*OB-ToggleNav' stamp: 'bs 1/15/2011 18:13:03.902'!
isNavViewVisible
	^ window submorphs includes: navView.! !

!OBSystemBrowser methodsFor: '*OB-ToggleNav' stamp: 'bs 1/15/2011 18:17:38.499'!
layoutPanels
	| builder |
	window addPaneSplitters.
	builder := OBMorphBuilder new.
	builder current: window do: [builder layoutPanels]
		! !

!OBSystemBrowser methodsFor: '*OB-ToggleNav' stamp: 'bs 1/15/2011 20:01:14.653'!
toggleNavigation
	self isNavViewVisible 
		ifTrue: [self turnOffNavView]
		ifFalse: [self turnOnNavView].! !

!OBSystemBrowser methodsFor: '*OB-ToggleNav' stamp: 'bs 1/17/2011 12:07:29.821'!
turnOffNavView
	self isNavViewVisible ifFalse: [^ self].
	window removeMorph: navView.
	window y: window y - navView height.
	window height: (window height - navView height).
	self layoutPanels.! !

!OBSystemBrowser methodsFor: '*OB-ToggleNav' stamp: 'bs 1/17/2011 12:07:40.625'!
turnOnNavView
	self isNavViewVisible ifTrue: [^ self].
	window addMorph: navView after: window submorphs first.
	window height: (window height + navView height).
	window y: window y + navView height.
	self layoutPanels.! !
